//----------------------------------------------------------------------------
// 
//	file: nettest.cc
// 
//	function: test netlayer class 
//	author:   Yoonsuck Choe <yschoe@cs.utexas.edu>
//	creation: Thu Jul 23 01:45:25 CDT 1998
// 
//	$Revision: 1.1 $ $Date: 1998/10/16 10:35:21 $
//	$Log: nettest.cc,v $
//	Revision 1.1  1998/10/16 10:35:21  yschoe
//	Initial revision
//
//
//----------------------------------------------------------------------------

#include <nnview/netlayer.h>
#include <nnview/spikelayer.h>
#include <nnview/simulog.h>
#include "real.h"

int main (int argc, char *argv[]) {

  simulog *netlog = new simulog("nettest.cc : test netlayer","nettest.log");

  spikelayer *inp_layer = new spikelayer("input",10,10,0,0,0,
					(netlayer *)NULL,0,0,0);

  cout << "Initializing map_layer1.\n";
  netlayer *map_layer = new netlayer("map",30,30,10,40,1,inp_layer,10,10,3);
  cout << "Initializing map_layer2.\n";
  netlayer *map_layer2 = new netlayer("map2",10,10,5,10,2,inp_layer,10,10,3);

  cout << "adding input layer to map_layer2.\n";
  map_layer2->add_inp_layer(map_layer,30,30,7);

  // inp_layer->save("nettest");
  // inp_layer->load("nettest");

  cout << "Initializing weights 1.\n";
  map_layer->init_weights(0.0,1.0);
  cout << "Normalizing weights 1.\n";
  map_layer->normalize_weights();
  cout << "Initializing weights 2.\n";
  map_layer2->init_weights(0.0,1.0);
  cout << "Normalizing weights 2.\n";
  map_layer2->normalize_weights();

//  cout << "Saving image\n";
//  map_layer->save("nettest");

 // cout << "Loading image\n";
 // map_layer->load("nettest");

  // map_layer->list();
  // inp_layer->list();
  // cout << "Listing map_layer2\n";
  //map_layer2->list();

  cout << "setting param\n" ;
  map_layer->set_parameter("set lat_inh_contri = 1.3");
  cout << "nettest: lat_inh_contri = " 
       << map_layer->get_parameter("lat_inh_contri") << endl;

  cout << "1.\n";
  map_layer->activate();
  netlog->append("map_layer : activate");
  map_layer->learn();
  cout << "2.\n";
  map_layer->activate();
  map_layer->learn();
  netlog->append("map_layer : activate");
  cout << "3.\n";
  map_layer->activate();
  map_layer->learn();
  netlog->append("map_layer : activate");
  cout << "4.\n";
  map_layer->activate();
  map_layer->learn();
  netlog->append("map_layer : activate");
 
  delete netlog;

}

