#!/usr/bin/wish

global win_size theta phi max_idx
set win_size 413

#----------------------------------------------------------------------------
# 	hsvtorgb
#----------------------------------------------------------------------------
proc HSVToRGB { colorBoxHue colorBoxSat colorBoxValue} {
# xf ignore me 6
# The HSV <-> RGB converting routines are from the
# tcolor demo that is part of the demo site of Tk.
# From: 
# http://www.mit.edu/afs/sipb/project/tcl/linuxbin/xfpixmap
#!/afs/sipb/project/tcl/wish -f
# Program: xfpixmap
# Tcl version: 6.6 (Tcl/Tk/XF)
# Tk version: 3.1
# XF version: $__lastrelease$

  set colorBoxV [format %.0f [expr 255.0*$colorBoxValue]]
  if {$colorBoxSat == 0} {
    return [format "#%02x%02x%02x" $colorBoxV $colorBoxV $colorBoxV]
  } else {
    set colorBoxHue [expr $colorBoxHue*6.0]
    if {$colorBoxHue >= 6.0} {
      set colorBoxHue 0.0
    }
    scan $colorBoxHue. %d i
    set colorBoxF [expr $colorBoxHue-$i]
    set colorBoxP [format %.0f [expr {255.0*$colorBoxValue*(1 - $colorBoxSat)}]]
    set colorBoxQ [format %.0f [expr {255.0*$colorBoxValue*(1 - ($colorBoxSat*$colorBoxF))}]]
    set colorBoxT [format %.0f [expr {255.0*$colorBoxValue*(1 - ($colorBoxSat*(1 - $colorBoxF)))}]]
    case $i       0 {return [format "#%02x%02x%02x" $colorBoxV $colorBoxT $colorBoxP]} \
      1 {return [format "#%02x%02x%02x" $colorBoxQ $colorBoxV $colorBoxP]} \
      2 {return [format "#%02x%02x%02x" $colorBoxP $colorBoxV $colorBoxT]} \
      3 {return [format "#%02x%02x%02x" $colorBoxP $colorBoxQ $colorBoxV]} \
      4 {return [format "#%02x%02x%02x" $colorBoxT $colorBoxP $colorBoxV]} \
      5 {return [format "#%02x%02x%02x" $colorBoxV $colorBoxP $colorBoxQ]}
    puts stderr "i value $i is out of range"
  }
}

#----------------------------------------------------------------------------
# 	plotnet: plot c.o.g.s net 
#----------------------------------------------------------------------------
proc plotnet { } {

	global win_size theta phi max_idx
	
 	set gran [expr $win_size/19 ];
	set length [expr $gran]

	for {set i 0} {$i<=180} {set i [expr $i + 10]} {
		set cy [expr $gran*$i/19*2+$gran/2]
		set cx [expr $win_size/18/2]
		# set val [expr $i/180.0]
		set val [expr 1.0-$i/180.0]
		set rad_theta [expr $i*3.141592/180.0]
		set offsetx [expr $length * cos($rad_theta)]
		set offsety [expr $length * sin($rad_theta)]
  		.misc.net create line   \
			[expr $cx-$offsetx/2.0] \
			[expr $cy-$offsety/2.0] \
			[expr $cx+$offsetx/2.0] \
			[expr $cy+$offsety/2.0] \
			-fill [HSVToRGB $val 1.0 1.0] \
			-width 6 
	}
}


#----------------------------------------------------------------------------
#
# 	MAIN:
#
#----------------------------------------------------------------------------
#----------------------------------------
# 1. Create polar line display window
#----------------------------------------
frame .misc -relief ridge; pack .misc -padx 10 -pady 10

canvas .misc.net -relief sunken -borderwidth 1 -background white \
	-height $win_size -width [expr $win_size/18];
pack .misc.net -side left -padx 10 -pady 5 ; 

button .psdump -command { \
        .misc.net postscript -file orkey-v.ps ; \
        } -text "PS Dump"
pack .psdump -side left

button .quit -command { exit } -text "Quit"
pack .quit -side top -padx 10 -pady 10

plotnet
